#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "gmmclib.h"

double gmmLProb(
		 long nmix,
		 double *wghts,
		 double *means,
		 double *vars,
		 double *gconsts,
		 long dim,
		 double *feav
		 )
{
  double gclp, prob;
  long m, i, j;

  prob = 0.0;
  for (m=0; m<nmix; m++) {
    gclp = 0.0;
    for (i=0; i<dim; i++) {
      j = m*dim+i;
      gclp += (means[j]-feav[i])*(means[j]-feav[i])/vars[j];
      //      printf("m%f v%f x%f\n", means[j], vars[j], feav[i]);
    }
    //    printf("gconst%f\n", gconsts[m]);
    gclp = - (gclp + gconsts[m])/2.0;
    prob += exp(gclp) * wghts[m];
    //        prob += gclp * wghts[m];
  }
  /*
  if (!isfinite(prob)) {
    printf("infinite!!\n"); exit(1);
  }
  */
  return log(prob);
  //  return prob;
}

